<template>
  <div class="vertical-menu-panel flex-grow-0 flex-column" v-bind:class="displayClass">
    <div class="bg-primary d-flex flex-row py-3">
      <h1 class="text-light my-0 py-2 px-3 flex-grow-1">
        <span class="mr-2">
          <font-awesome-icon icon="calendar-alt"></font-awesome-icon>
        </span>
        {{ title }}
      </h1>
      <button class="btn text-light flex-grow-0 mr-2 close-btn" @click="close">
        <font-awesome-icon icon="times"></font-awesome-icon>
      </button>
    </div>

    <div class="d-flex flex-column flex-grow-1 pt-3 mx-4">
      <h2>Data de previsão</h2>
      <div>
        <date-picker v-model="datetime"
          :inline="true"
          :lang="lang"
          :disabled-date="archiveRange">
        </date-picker>
      </div>
      <hr>
      <h2>Modo</h2>
      <div class="btn-group btn-group-toggle mx-auto" data-toggle="buttons">
        <label class="btn btn-primary btn-sm active">
          <input type="radio" name="options" id="option1" checked>
          Previsão
        </label>
        <label class="btn btn-light btn-sm">
          <input type="radio" name="options" id="option1" checked>
          Observação
        </label>
      </div>
    </div>
  </div>
</template>

<script>
// Vendor
import moment from 'moment'
import DatePicker from 'vue2-datepicker'

import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'
import { CHANGE_PANEL, CHANGE_REFERENCE_TIME, mutationNameResolve } from '@/store/workspace/mutations'

export default {
  name: 'referencetimepanel',

  mixins: [
    ParentWorkspaceMixin,
  ],

  props: {
    title: {
      type: String,
      default: 'Camadas'
    },
    name: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      lang: {
        formatLocale: {
          months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
          weekdaysShort: ['Dom', 'Seg', 'Ter', 'Qua', 'Qui', 'Sex', 'Sab'],
          weekdaysMin: ['Do', '2º', '3ª', '4ª', '5ª', '6ª', 'Sa'],
        },
      },
    }
  },

  computed: {
    datetime: {
      get() {
        return moment.unix(this.referenceTime).toDate()
      },

      set(value) {
        this.$store.commit(mutationNameResolve(this.workspace, CHANGE_REFERENCE_TIME), {
          referenceTime: moment(value).unix()
        })
      },
    },

    currentPanel: {
      get() {
        return this.$store.state[this.workspace].currentPanel
      }
    },

    referenceTime: {
      get() {
        return this.$store.state[this.workspace].referenceTime
      }
    },

    displayClass: {
      get() {
        return this.currentPanel === this.name ? 'd-flex' : 'd-none'
      }
    },
  },

  methods: {
    close() {
      this.$store.commit(mutationNameResolve(this.workspace, CHANGE_PANEL), { panel: this.name })
    },

    notAfterToday(date) {
      let today = moment.utc()
      return date > today.toDate()
    },

    archiveRange(date) {
      let today = moment.utc()
      return date > today.toDate() || date < today.clone().subtract(5, 'days').toDate()
    },
  },

  components: {
    DatePicker
  },
}
</script>

<style>
.vertical-menu-panel {
  font-size: 0.8em;
  line-height: 1.8em;
}

.vertical-menu-panel h1 {
  font-weight: lighter;
}

h2 {
  font-weight: lighter;
  color: #73879c;
}

.vertical-menu-panel button.btn.close-btn {
  border-radius: 2rem;
  height: max-content;
  width: max-content;
  margin-top: auto;
  margin-bottom: auto;
}

.vertical-menu-panel button.btn.close-btn:hover {
  background-color: #008eff !important;
}

.vertical-menu-panel div.mx-datepicker-main {
  border: none;
}
.vertical-menu-panel hr {
  height: 1px;
  border: 0;
  border-top: 1px solid #ccc;
  margin: 1em 0;
  padding: 0;
}
</style>
